from typing import TYPE_CHECKING

from api.v1.common.base_models import TenantScopedMixin, TimestampMixin
from core.database import Base
from sqlalchemy import (
    ForeignKeyConstraint,
    Integer,
    PrimaryKeyConstraint,
    SmallInteger,
    String,
    UniqueConstraint,
)
from sqlalchemy.orm import Mapped, mapped_column, relationship

if TYPE_CHECKING:
    from api.v1.modules.a76.pedmientos.models.pedimentos import Pedimentos


class PedimentoTransportMeans(Base, TenantScopedMixin, TimestampMixin):
    __tablename__ = "pedimento_transport_means"
    __table_args__ = (
        PrimaryKeyConstraint("id", name="pedimento_transport_means_pkey"),        
        ForeignKeyConstraint(
            ["pedimento_id"],
            ["a76.pedimentos.id"],
            ondelete="CASCADE",
            name="fk_pedimento_transport_means",
        ),
        UniqueConstraint(
            "tenant_id",
            "company_id",
            "pedimento_id",
            name="pedimento_transport_means_pedimento_id_key",
        ),
        {"schema": "a76"},
    )

    id: Mapped[int] = mapped_column(Integer)
    pedimento_id: Mapped[int] = mapped_column(Integer, nullable=False)

    destination: Mapped[int] = mapped_column(SmallInteger)
    entry_exit: Mapped[str] = mapped_column(String(3))
    arrival: Mapped[str] = mapped_column(String(3))
    departure: Mapped[str] = mapped_column(String(3))

    pedimento: Mapped["Pedimentos"] = relationship(
        "Pedimentos", back_populates="pedimento_transport_means"
    )
